'Eine streng typisierte Collection fr unterschiedliche Objekte, die von ElementBase erben
'Das Serializable-Attribut ist erforderlich, um Code fr Objekte zur Design Time zu generieren. 
<Serializable()> _
Public Class ElementCollection
    Inherits CollectionBase
    Event PropertyChanged()

    Public Function Add(ByVal Item As Object) As Object
        CType(Item, ElementBase).Collection = Me
        List.Add(Item)
        RaisePropertyChangedEvent()
        Return Item
    End Function
    Public Sub AddRange(ByVal Items() As Object)
        For Each Item As Object In Items
            CType(Item, ElementBase).Collection = Me
            List.Add(Item)
        Next
        RaisePropertyChangedEvent()
    End Sub
    Default Public ReadOnly Property Item(ByVal Index As Integer) As ElementBase
        Get
            Return CType(List(Index), ElementBase)
        End Get
    End Property
    Friend Sub RaisePropertyChangedEvent()
        RaiseEvent PropertyChanged()
    End Sub

    Protected Overrides Sub OnInsert(ByVal index As Integer, ByVal value As Object)
        MyBase.OnInsert(index, value)
        RaiseEvent PropertyChanged()
    End Sub
    Protected Overrides Sub OnRemove(ByVal index As Integer, ByVal value As Object)
        MyBase.OnRemove(index, value)
        RaiseEvent PropertyChanged()
    End Sub
End Class
